/*
Original KS0108 control code from
http://www.ee.oulu.fi/~mainfram/lcd.htm

Some BMP conversion routines from Dincer Aydin's bmp2lcd program:
http://www.geocities.com/dinceraydin/lcd/gfxfin.htm
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "font.h"
#include "font2.h"
#include <math.h>
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDLPortIO"
#pragma resource "*.dfm"
TForm1 *Form1;

typedef unsigned char byte;
#define SIZEBMP 1086
#define SIZELCD 1024
static int i;
byte count, arrayLCD[SIZELCD], arrayBmp[SIZEBMP];

  //displaytech
#define DISPLAY_ON         0x3f  //0011 1111
#define DISPLAY_OFF        0x3e  //0011 1110
#define DISPLAY_STARTLINE  0xc0  //1100 0000   <<<<<
#define DISPLAY_PAGE_SET   0xb8  //1011 1000
#define DISPLAY_COLUMN_SET 0x40  //0100 0000
#define DATAREG 0x378    //lpt1
#define CONTROL 0x37A
//  #define DATAREG 0x278    //lpt2
//  #define CONTROL 0x27A
//    #define DATAREG 0x3BC    //lpt3

/*
The input register is a register that is used for temporarily storing the data to be written
in the display data RAM. The data to be written from the MPU to the input register will be
automatically written in the display data RAM through internal operation.
When the Chip Select is selected and  D/I = 0, the data is written in the register,
synchronized with the fall of signal E.
 di=0 == instruction write
 di=1 == data write
#define
*/									 //8421
#define LCD_ENABLE      1   //0001  Inverted PIN !!!
#define LCD_CS1         0	 //0000  Inverted PIN !!!
#define LCD_CS2         6   //0110
#define LCD_inst        8   //1000  Inverted PIN !!!  di tai rs
//#define LCD_DATA        4   //0100
//#define LCD_BACKLIGHT   8   //1000  Inverted PIN !!!

unsigned char CurrentColumn,DisplayData[8*128+1], CharacterTbl[256*32+1];
unsigned int a;

unsigned char tractor[8][128]=
   {{0x00,0x00,0x08,0x40,0x00,0x80,0x00,0x08,
		 0x00,0x00,0x08,0x00,0x20,0x00,0x80,0x20,
		 0xA4,0x48,0xAC,0x08,0xAC,0x90,0x08,0x90,
		 0x08,0x50,0x48,0xB0,0x28,0xC0,0x58,0x60,
		 0xA8,0xC0,0x38,0xC0,0x58,0x50,0xA0,0x58,
		 0xD0,0x90,0x50,0x50,0x50,0xB0,0x40,0x50,
		 0xD0,0x10,0xE0,0x10,0xE0,0x10,0x60,0x40,
		 0xB0,0x40,0xA0,0xA0,0x40,0xA0,0x40,0xA8,
		 0xAA,0x42,0xE0,0xA2,0xC0,0x24,0xDC,0x68,
		 0x48,0xD8,0xB0,0xA8,0x54,0xE8,0xB8,0x20,
		 0xE8,0x58,0x70,0xE0,0x20,0xE0,0x40,0x40,
		 0x50,0x40,0xD0,0xE0,0x50,0xF8,0xB0,0x6C,
		 0xFC,0x54,0xFC,0x9C,0x74,0x5C,0xAC,0x54,
		 0xEC,0x54,0xFC,0xA0,0x50,0xF4,0xA0,0xD8,
		 0xE0,0xA0,0x40,0xC4,0x48,0xC0,0x80,0x00,
		 0x14,0x00,0x00,0x08,0x10,0x80,0x00,0x00},
		{0x00,0x00,0x20,0x00,0x10,0x00,0x80,0x01,
		 0x00,0x00,0x04,0x40,0x00,0x00,0x01,0xEA,
		 0xBD,0xD2,0x2D,0x66,0x4A,0xDD,0x22,0x54,
		 0x25,0xDE,0x22,0x5D,0xF3,0x26,0xCD,0x12,
		 0xC2,0x3F,0xC9,0x21,0xC1,0x32,0xE5,0xDE,
		 0xA2,0xDD,0x93,0x7D,0xC2,0xBD,0xC3,0x3C,
		 0xCB,0x32,0x4D,0x5A,0x55,0x6B,0x15,0xFA,
		 0x83,0x7C,0x45,0x6A,0xCB,0xBA,0xA5,0x5A,
		 0xD5,0xDE,0xB2,0xED,0x13,0xEE,0xBB,0x55,
		 0xEF,0x5A,0xED,0xBB,0xD6,0xBD,0x93,0x2D,
		 0x42,0x1D,0x11,0xD1,0x95,0xF1,0xDA,0x75,
		 0xEF,0xBB,0xDE,0xB7,0xAB,0x4D,0x5B,0x64,
		 0x5F,0xFA,0x52,0xED,0xBB,0xEF,0xBA,0x75,
		 0x6F,0xBD,0xCA,0x1F,0x3B,0x46,0xBD,0x06,
		 0xBF,0x95,0x2F,0xDD,0x3B,0x6E,0xEB,0x5F,
		 0xFC,0xB9,0x74,0xE0,0x80,0x00,0x22,0x00},
		{0x00,0x00,0x04,0x00,0x20,0x00,0x00,0x12,
		 0x80,0x00,0x00,0x01,0x40,0x00,0x00,0x9A,
		 0xB5,0x6F,0x90,0x6F,0x90,0xB5,0x03,0xDA,
		 0x82,0x39,0xC3,0x3C,0xD3,0x2E,0x51,0x82,
		 0x2D,0x9A,0x21,0x84,0x1B,0x72,0xAF,0x6A,
		 0x3A,0xE5,0xDF,0x2A,0x0A,0xAB,0x7A,0xDB,
		 0xE2,0xBF,0xD5,0x6E,0xD3,0xAD,0xE2,0xBE,
		 0x63,0xDE,0x75,0xAB,0xFA,0xC3,0x9E,0x71,
		 0xA6,0xFD,0x95,0x7F,0xC2,0x7D,0xE6,0x5F,
		 0xFA,0xB7,0xED,0xAA,0x6F,0xBA,0xCB,0xBD,
		 0xEB,0x5E,0xEB,0xDE,0x6B,0xDE,0x75,0xCF,
		 0x7A,0x5A,0x35,0x54,0x98,0x73,0xCE,0xBD,
		 0xF5,0x2F,0xFB,0x8E,0x53,0xCE,0xBA,0x67,
		 0x5A,0xFD,0xBB,0x65,0xDF,0xBE,0x75,0xAF,
		 0x7A,0x56,0x6B,0x7C,0xF3,0x24,0x61,0x87,
		 0xAA,0x1F,0xFB,0xB6,0x57,0xFE,0xC0,0x00},
		{0x00,0x00,0x00,0x04,0x00,0x08,0x80,0x00,
		 0x80,0x88,0x90,0x40,0xC0,0x40,0xC0,0xCE,
		 0x39,0x56,0xE5,0xAA,0x55,0xB5,0x64,0xCC,
		 0xB1,0xA4,0xD5,0xA2,0xE5,0xDE,0x30,0x66,
		 0xCC,0x38,0xF3,0x05,0xD1,0x4B,0x20,0xC5,
		 0xBB,0x02,0xF5,0x9D,0x24,0x43,0xA6,0x9F,
		 0x20,0x47,0xDD,0x27,0xEC,0x0A,0x59,0x94,
		 0x0D,0xFD,0xCA,0x2A,0xDB,0xFC,0x9B,0xF6,
		 0x0A,0xED,0xA3,0xA6,0x5D,0xDB,0xB5,0x2E,
		 0xDB,0x96,0x75,0xEF,0x5D,0xFA,0xDF,0xF2,
		 0xAF,0x7D,0xD6,0x6F,0x9A,0x77,0xDC,0x73,
		 0xAD,0x4A,0xBD,0x26,0xDD,0xD3,0x7D,0xD7,
		 0xFD,0x03,0xEE,0xB9,0xEF,0xBA,0x5F,0xF3,
		 0xAF,0xA2,0x55,0xEA,0x95,0xAD,0x53,0xAD,
		 0x5B,0xA3,0x5F,0xF0,0x47,0x8B,0xA5,0x0C,
		 0x21,0x00,0xFF,0xAB,0xFE,0x2D,0x79,0x00},
		{0x00,0x44,0xA0,0xB9,0x64,0xDA,0xA2,0x7F,
		 0xDA,0xF7,0xBD,0x57,0xFD,0xB7,0xEE,0x17,
		 0xE4,0x5B,0xFE,0xD5,0xAF,0x7D,0xDB,0xEE,
		 0xBB,0xEE,0x0D,0x0A,0x17,0x8D,0x4B,0x4C,
		 0xE7,0xAC,0x55,0x7E,0xD0,0xB2,0xB4,0x4D,
		 0xFB,0x56,0xDA,0xF2,0x95,0x70,0xAE,0xD1,
		 0x95,0x8A,0x02,0x0E,0x01,0x07,0x0C,0x4F,
		 0x3A,0xD5,0x37,0xEA,0xB7,0x6C,0xDB,0xFD,
		 0xAA,0x7D,0xEA,0xAF,0x55,0xC6,0xAF,0x92,
		 0x0F,0x4A,0x6D,0xA6,0x9F,0xAA,0x8E,0x52,
		 0xE3,0xA7,0xFD,0x69,0xE3,0xCE,0x3D,0xED,
		 0xBA,0x6F,0xDD,0x3B,0xE6,0xDD,0x77,0xDD,
		 0xF7,0xBA,0xD6,0x25,0xDA,0xCF,0xBB,0x5E,
		 0xF5,0xDF,0xBA,0x37,0xEA,0x9F,0x74,0x5A,
		 0xC0,0xBE,0x65,0x5D,0xAF,0x08,0x10,0xC2,
		 0xA0,0xFE,0xBD,0xE7,0x1D,0x8F,0x08,0x00},
		{0x00,0x37,0x6E,0xFB,0xB7,0xEE,0x5B,0xFF,
		 0x6A,0xFF,0xAD,0xFB,0xAE,0x7D,0x98,0x77,
		 0xDD,0x36,0xEF,0x3A,0xF7,0xAD,0xFE,0xB5,
		 0x6F,0xDD,0xB9,0x4C,0xF3,0xBC,0xC7,0xBB,
		 0xEC,0x3B,0xFD,0x12,0xFF,0xA5,0x2B,0xDD,
		 0xBB,0x23,0x5E,0xE9,0xAF,0xBB,0x26,0x5D,
		 0xEE,0x6B,0xDE,0x78,0xC4,0x00,0x08,0x90,
		 0x00,0x01,0x08,0x43,0x45,0x47,0x2E,0xDB,
		 0x3F,0xD5,0x3F,0x75,0xAF,0x7F,0xBA,0xD7,
		 0xBF,0x5B,0x6F,0xFA,0xAF,0xBB,0x7F,0xA5,
		 0xFE,0x1F,0xF5,0x5D,0xF3,0xAC,0xDB,0x7A,
		 0xD7,0xDD,0xBB,0xD7,0xBE,0xEB,0xFB,0xB6,
		 0xED,0x5F,0xFD,0xAE,0x7A,0xED,0xDB,0xBA,
		 0xE3,0xE5,0x23,0xE1,0xCA,0x51,0xE5,0xB5,
		 0xE0,0xD2,0xB4,0x68,0xDC,0x7B,0xEE,0xBB,
		 0x6E,0xDB,0x31,0xE3,0x14,0xE8,0xA2,0x68},
		{0x40,0x81,0x08,0x23,0x02,0x4F,0x0D,0x5B,
		 0x16,0x2F,0x5A,0x1F,0x55,0x0F,0x9A,0x1F,
		 0x15,0x4E,0x2F,0x0B,0x96,0x0F,0x2A,0x85,
		 0x3D,0x2E,0xFB,0x4F,0xFC,0x6B,0xFE,0xD5,
		 0x5F,0xF5,0xAE,0x5A,0xEE,0x39,0xE2,0x9C,
		 0x7D,0x93,0x6D,0x5A,0x35,0x66,0xAD,0xA0,
		 0x5F,0xF9,0xB7,0x4D,0x15,0x2E,0x08,0xB2,
		 0x05,0xA4,0x29,0x46,0x09,0x5A,0x01,0x94,
		 0x83,0x04,0x13,0x84,0x03,0x02,0x8A,0x02,
		 0x01,0x27,0x01,0x06,0x22,0x05,0x23,0x02,
		 0x81,0x05,0x00,0x45,0x00,0x84,0x09,0x12,
		 0x41,0x02,0x21,0x04,0x0B,0x42,0x9B,0x05,
		 0x3F,0x2D,0x1B,0x3F,0x1D,0xBB,0x16,0xBD,
		 0x17,0x1F,0xBB,0x2E,0x1B,0x37,0x4E,0x1B,
		 0x1D,0x47,0x8D,0x17,0x05,0x4F,0x0C,0xA3,
		 0x05,0x05,0x97,0x02,0x03,0x22,0x05,0x01},
		{0x00,0x42,0x08,0x42,0x90,0x02,0x20,0x81,
		 0x14,0x00,0x82,0x08,0x12,0x80,0x02,0x88,
		 0x10,0x02,0x11,0x00,0x20,0x02,0x40,0x00,
		 0x05,0x08,0x13,0x07,0x2A,0x1F,0x31,0x2F,
		 0x7B,0x2E,0x5B,0x7E,0x3D,0x63,0x5C,0x75,
		 0x2E,0xB9,0x16,0x3D,0x15,0x1F,0x12,0x0F,
		 0x23,0x04,0x1A,0x04,0x01,0x0A,0x02,0x04,
		 0x0A,0x81,0x02,0x09,0x01,0x41,0x00,0x02,
		 0x00,0x01,0x04,0x08,0x00,0x88,0x00,0x00,
		 0x04,0x10,0x82,0x00,0x00,0x80,0x09,0x00,
		 0x90,0x00,0x02,0x08,0x90,0x00,0x00,0x12,
		 0x00,0x11,0x00,0x02,0x40,0x08,0x40,0x81,
		 0x08,0x21,0x00,0x01,0x20,0x04,0x40,0x02,
		 0x40,0x04,0x08,0x21,0x00,0x14,0x00,0x82,
		 0x08,0x00,0x20,0x02,0x08,0x00,0x22,0x00,
		 0x80,0x04,0x08,0x01,0x20,0x41,0x04,0x00}};
/////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  StartLPTDriver();
}

//---------------------------------------------------------------------------


void __fastcall TForm1::OmaDelay(void)
{
  //Sleep(1);

  unsigned int viive=Edit1->Text.ToInt();
  Delay(viive);
  /*
  long aa,a,b=1;
  	for(aa=0;aa < viive ;aa++)
  	{for(a=0;a < 1024 ;a++) 	b=a/3;}
  */
}

void __fastcall TForm1::Delay(long microseconds)
{

LARGE_INTEGER liFreq;
LARGE_INTEGER liCnt;
LARGE_INTEGER liStart;
LONGLONG ticksPerMilliSec = 0;

if ( QueryPerformanceFrequency(&liFreq) )
{
  ticksPerMilliSec = (liFreq.QuadPart)/1000000;
}
else 
{
// MessageBox(NULL,"Error obtaining frequency\n",0,NULL);
}

if ( QueryPerformanceCounter(&liStart) )
{
do
{
  QueryPerformanceCounter(&liCnt);
}  while ( (liStart.QuadPart + (__int64)(ticksPerMilliSec * microseconds)) > liCnt.QuadPart );
}

}


void __fastcall TForm1::StartLPTDriver(void)
{
        //ajurin hakemisto
        DLPortIO1->DriverPath=ExtractFileDir(ParamStr(0));
        // ajurin avaus
        DLPortIO1->OpenDriver();
        if (!DLPortIO1->ActiveHW)
   {
      MessageDlg("Could not open the DriverLINX driver.",
                 mtError, TMsgDlgButtons() << mbOK, 0);
   }
}

void  __fastcall TForm1::SendLCDCommand(unsigned char value, unsigned char CS)
{
 /*
 OmaDelay();
 DLPortIO1->PortW[CONTROL] = LCD_ENABLE | CS | LCD_inst;  // cs , rs/di = 0 e=1 <<chip select, instruction write , enable yls
 //OmaDelay();
 DLPortIO1->PortW[DATAREG] = value;  //bittikuvio datavyln
 //OmaDelay();
 DLPortIO1->PortW[CONTROL] = CS | LCD_inst;  //cs , rs/di = 0 e=0 <<chip select, instruction write , enable alas
 OmaDelay();
 DLPortIO1->PortW[CONTROL] = LCD_ENABLE | CS | LCD_inst;

 DLPortIO1->PortW[DATAREG] = 0;
 //OmaDelay();
 */

 OmaDelay();
 DLPortIO1->PortW[CONTROL] = LCD_ENABLE | CS | LCD_inst;  // cs , rs/di = 0 e=1 <<chip select, instruction write , enable yls
 OmaDelay();
 DLPortIO1->PortW[DATAREG] = value;  //bittikuvio datavyln
 OmaDelay();
 DLPortIO1->PortW[CONTROL] = CS | LCD_inst;  //cs , rs/di = 0 e=0 <<chip select, instruction write , enable alas
 OmaDelay();
 DLPortIO1->PortW[CONTROL] = LCD_ENABLE | CS | LCD_inst;
 OmaDelay();
 DLPortIO1->PortW[DATAREG] = 0;
}

void __fastcall TForm1::SendLCDData(const unsigned char values[], unsigned int amount)
{
 unsigned char cs;
 int counter;
 for (counter=0; counter < amount;counter++)
 {
    cs = CurrentColumn>63?LCD_CS2:LCD_CS1;   //
    /*
    OmaDelay();
    DLPortIO1->PortW[CONTROL] = LCD_ENABLE | cs;   // cs , rs/di = 1 e=1 <<chip select, data write , enable yls
    //OmaDelay();

    DLPortIO1->PortW[DATAREG] = values[counter];  //bittikuvio datavyln
    //OmaDelay();

    DLPortIO1->PortW[CONTROL] = cs;  // cs , rs/di = 1 e=0 <<chip select, data write , enable alas
    OmaDelay();
    DLPortIO1->PortW[CONTROL] = LCD_ENABLE | cs;
    */

    OmaDelay();
    DLPortIO1->PortW[CONTROL] = LCD_ENABLE | cs;   // cs , rs/di = 1 e=1 <<chip select, data write , enable yls
    OmaDelay();
    DLPortIO1->PortW[DATAREG] = values[counter];  //bittikuvio datavyln
    OmaDelay();
    DLPortIO1->PortW[CONTROL] = cs;  // cs , rs/di = 1 e=0 <<chip select, data write , enable alas
    OmaDelay();
    DLPortIO1->PortW[CONTROL] = LCD_ENABLE | cs;

    CurrentColumn++;
    if (CurrentColumn > 127)
    	return;
 }
}

/*
void TForm1::WriteData(BYTE Data)
{
  unsigned char cs;
  cs = CurrentColumn>63?LCD_CS2:LCD_CS1;
  DLPortIO1->PortW[CONTROL] = cs;
  OmaDelay();
  DLPortIO1->PortW[DATAREG] = Data;
  OmaDelay();
  DLPortIO1->PortW[CONTROL] = LCD_ENABLE | cs;
  OmaDelay();
  CurrentColumn++;
    if (CurrentColumn > 127)
    	return;
}
*/

void __fastcall TForm1::SetColumn(unsigned char y)
{
  //assert(y < 128);
  CurrentColumn = y;
  if (y < 64)
  {
     SendLCDCommand(DISPLAY_COLUMN_SET | (y&63), LCD_CS1);
     SendLCDCommand(DISPLAY_COLUMN_SET | 0, LCD_CS2);
  } else
  {
     SendLCDCommand(DISPLAY_COLUMN_SET | 63, LCD_CS1);
     SendLCDCommand(DISPLAY_COLUMN_SET | ((y-64)&63), LCD_CS2);
  }
}

void __fastcall TForm1::SetPage(unsigned char x)
{
  //assert( x < 8);
  SendLCDCommand(DISPLAY_PAGE_SET | x, LCD_CS1);
  SendLCDCommand(DISPLAY_PAGE_SET | x, LCD_CS2);
}

void __fastcall TForm1::SetStartLine(unsigned char line)
{
  SendLCDCommand(DISPLAY_STARTLINE | (line & 63), LCD_CS1);
  SendLCDCommand(DISPLAY_STARTLINE | (line & 63), LCD_CS2);
}

void __fastcall TForm1::putpixel(unsigned int x, unsigned int y, unsigned char toggle)
{
  DisplayData[(x&127)+(((y&63) >> 3) << 7)] |= 1 << (y & 7);
}

void __fastcall TForm1::LCDprintf(unsigned char y, unsigned char page, char *Str)
{
  unsigned char n;

  SetColumn(y);
  SetPage(page);
  SetColumn(y);

  for (n = 0;n < strlen(Str);n++)
  {
    SendLCDData(&Character8x8[*(Str+n)*8], 8);
  }
}

void TForm1::SetLCDXY(int x, int y)
{
SetColumn(x*8);
SetPage(y);
}

void TForm1::SetLCDXY2(int x, int y)
{
SetColumn(x*6);
SetPage(y);
}

void TForm1::PrintLCDText(char *string)
{
  int n;

  for (n = 0;n < strlen(string);n++)
  {
    SendLCDData(&Character8x8[*(string+n)*8], 8);
  }
}

void TForm1::PrintLCDText2(char *string)
{
  unsigned char n;
  unsigned char value = 0x0;

  for (n = 0;n < strlen(string);n++)
  {
    SendLCDData(&font5x7[((*(string+n)-32) * 5)],5);
    SendLCDData(&value,1);
  }

}

void __fastcall TForm1::ClearLCD()
{
  unsigned char value;
  int x, a;
  value = 0x0;

  //SendLCDCommand(DISPLAY_ON, LCD_CS1);
  //SendLCDCommand(DISPLAY_ON, LCD_CS2);
  SetStartLine(0);

  for (x=0;x < 8;x++)
    {
      SetPage(x);SetColumn(0);
      for (a = 0 ;a < 128; a++)
      SendLCDData(&value, 1);
    }
}

void __fastcall TForm1::InitLCD()
{
  unsigned char value;
  int x, a;
  value = 0x0;

  SendLCDCommand(DISPLAY_ON, LCD_CS1);
  SendLCDCommand(DISPLAY_ON, LCD_CS2);
  SetStartLine(0);

  for (x=0;x < 8;x++)
    {
      SetPage(x);SetColumn(0);
      for (a = 0 ;a < 128; a++)
      SendLCDData(&value, 1);
    }
  /*
  LCDprintf(0,0,"================");
  LCDprintf(0,1,"    128 x 64    ");
  LCDprintf(0,2," dot matrix LCD ");
  LCDprintf(0,3,"================");
  LCDprintf(0,4," test program   ");
  */
  SetLCDXY2(0,0);
  PrintLCDText2("PrintLCDText");
  SetLCDXY2(1,1);
  PrintLCDText2("SetLCDXY(1,1)");
  SetLCDXY2(2,2);
  PrintLCDText2("SetLCDXY(2,2)");
  SetLCDXY2(3,3);
  PrintLCDText2("SetLCDXY(3,3)");
  SetLCDXY2(2,6);
  PrintLCDText2("SetLCDXY(2,6)");

}

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  ClearLCD();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  SetStartLine(0);
  for(int i=0;i<8;i++)
    {
      if (CheckBox1->Checked)
        LCDprintf2(0,i,Memo1->Lines->Strings[i].c_str());
      else
        LCDprintf(0,i,Memo1->Lines->Strings[i].c_str());
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  InitLCD();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  SetColumn(0);
  SetPage(0);
  //SetColumn(i);

  for (int j=0;j<8;j++)
  {
    SetPage(j);
    SetColumn(0);
    for (int i=0;i<128;i++)
    {
      SendLCDData(&tractor[j][((i) * 1)],1);
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LCDprintf2(unsigned char y, unsigned char page, char *Str)
{
  unsigned char n;

  for (n = 0;n < strlen(Str);n++)
  {
    putchr(y+n*6, page, *(Str+n));
  }
}

void __fastcall TForm1::putchr(unsigned char y, unsigned char page, char chr)
{
  SetColumn(y);
  SetPage(page);
  //SetColumn(y);

  SendLCDData(&font5x7[((chr-32) * 5)],5);
}

void TForm1::convert(void)
{
  byte i,j,k,bmpCol,page,bitPos,dByte = 0;
  byte oneBlock[8];

  for(page=0;page<8;page++)
  {
    for(bmpCol=0;bmpCol<16;bmpCol++)
    {
      for(i=0;i<8;i++)
              oneBlock[i] = arrayBmp[SIZEBMP -1 - i*16 - page*16*8 - bmpCol];
      for(bitPos=0;bitPos<8;bitPos++)
      {
        dByte = 0;
        for(i=0;i<8;i++)
        {    if(getbits(oneBlock[i], bitPos, 1))
          dByte += (byte)pow((double)2, (double)i);
        }
        arrayLCD[(page * 128) + 127 - (bmpCol * 8) - bitPos]= ~dByte;
      }
    }
  }
}

/* getbits:  get n bits from position p */
 unsigned char TForm1::getbits(unsigned x, int p, int n)
   {
       return (x >> (p+1-n)) & ~(~0 << n);
   }

void __fastcall TForm1::Button6Click(TObject *Sender)
{
    SetPage(0);
    SetColumn(0);
    for(int j=0;j<8;j++)
    {
    SetPage(j);
    SetColumn(0);
    for(int i=0;i<128;i++)
    {
    putchr(i, j, ' ');
    putchr(i+4, j, '#');
    Sleep(100);
    //ClearLCD();
    }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
  OpenPictureDialog1->Execute();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
  Graphics::TBitmap *pBitmap = new Graphics::TBitmap();
  try
  {

    pBitmap->LoadFromFile(OpenPictureDialog1->FileName);
    Canvas->Draw(340,100,pBitmap);


    FILE *fp;
    fp = fopen(OpenPictureDialog1->FileName.c_str(), "rb");
    fread(arrayBmp, sizeof( byte), SIZEBMP, fp);
    fclose(fp);
    convert();

    for (int j=0;j<8;j++)
    {
      SetPage(j);
      SetColumn(0);
      for (int i=0;i<128;i++)
      {
        SendLCDData(&arrayLCD[((i+128*j) * 1)],1);
      }
    }
    /*
    for(int page=0;page<8;page++)
    {
      for(int col=0;col<128;col++)
      {
        BYTE lcdValue = 0;
        for(int bit=8;bit>1;bit--)
        {
          lcdValue |= (pBitmap->Canvas->Pixels[col][page*8+bit]!=0 ? (byte)0 : (byte)1);
          lcdValue <<= 1;
        }
        lcdValue |= (pBitmap->Canvas->Pixels[col][page*8+1]!=0 ? (byte)0 : (byte)1);

        SetPage(page);
        SetColumn(col);
        SendLCDData(&lcdValue,1);
      }

    }
    */
  }

  catch (...)

  {
    ShowMessage("Could not load or display bitmap");
  }
  delete pBitmap;
}
//---------------------------------------------------------------------------

